package com.casic.dcms.ui;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.TextUtils;
import android.view.View;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.GridLayoutManager;

import com.casic.dcms.R;
import com.casic.dcms.adapter.NineGridImageAdapter;
import com.casic.dcms.base.AndroidxBaseActivity;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.databinding.ActivityUploadPackageBinding;
import com.casic.dcms.mvp.presenter.impl.ShopCaseSubmitPresenterImpl;
import com.casic.dcms.mvp.presenter.impl.UploadImagePresenterImpl;
import com.casic.dcms.mvp.view.ICaseSubmitView;
import com.casic.dcms.mvp.view.IUploadFileView;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.OtherUtils;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.ToastHelper;
import com.luck.picture.lib.PictureSelector;
import com.luck.picture.lib.config.PictureConfig;
import com.luck.picture.lib.entity.LocalMedia;
import com.luck.picture.lib.tools.PictureFileUtils;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUITipDialog;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class CaseUploadPackageActivity extends AndroidxBaseActivity<ActivityUploadPackageBinding> implements IUploadFileView, ICaseSubmitView {

    private final Context context = this;
    private UploadImagePresenterImpl uploadImagePresenter;
    private ShopCaseSubmitPresenterImpl shopCaseSubmitPresenter;
    private NineGridImageAdapter imageAdapter;
    private QMUITipDialog submitDialog;
    private final ArrayList<String> realPaths = new ArrayList<>();//真实图片路径
    private final List<String> imageList = new ArrayList<>();//上传到服务器的数据集
    private String gridId, shopID;

    private final ActivityResultLauncher<Intent> packageCaseLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                double longitude = data.getDoubleExtra("longitude", 0);
                double latitude = data.getDoubleExtra("latitude", 0);
                gridId = data.getStringExtra("gridId");
                String community = data.getStringExtra("community");
                String shopName = data.getStringExtra("shopName");
                shopID = data.getStringExtra("shopID");

                viewBinding.longitudeView.setText(String.valueOf(longitude));
                viewBinding.latitudeView.setText(String.valueOf(latitude));
                viewBinding.communityNameView.setText(community);
                viewBinding.shopView.setText(shopName);
                viewBinding.shopView.setTextColor(ContextCompat.getColor(context, R.color.textColor));
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        viewBinding.titleBarLayout.titleView.setText("三包上报");
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    public void initData() {
        uploadImagePresenter = new UploadImagePresenterImpl(this);
        shopCaseSubmitPresenter = new ShopCaseSubmitPresenterImpl(this);
        submitDialog = new QMUITipDialog.Builder(this)
                .setIconType(QMUITipDialog.Builder.ICON_TYPE_LOADING)
                .setTipWord("处理中，请稍后")
                .create();

        imageAdapter = new NineGridImageAdapter(this);
        viewBinding.selectedGridViewView.setLayoutManager(new GridLayoutManager(this, 2));
        viewBinding.selectedGridViewView.setAdapter(imageAdapter);
    }

    @Override
    public void initEvent() {
        viewBinding.shopLayout.setOnClickListener(view -> {
            Intent intent = new Intent(context, ArcGISMapActivity.class);
            intent.putExtra("type", "三包上报");
            packageCaseLauncher.launch(intent);
        });

        viewBinding.submitButton.setChangeAlphaWhenPress(true);
        viewBinding.submitButton.setOnClickListener(view -> submitCase());

        //图片九宫格事件处理
        imageAdapter.setOnItemClickListener(new NineGridImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                new QMUIDialog.MenuDialogBuilder(context)
                        .addItem("相册中选取", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                                OtherUtils.selectPicture(CaseUploadPackageActivity.this);
                            }
                        })
                        .addItem("相机拍照", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                                OtherUtils.takePicture(CaseUploadPackageActivity.this);
                            }
                        })
                        .setCanceledOnTouchOutside(false)
                        .create().show();
            }

            @Override
            public void onItemClick(int position) {
                OtherUtils.showBigImage(context, position, realPaths);
            }

            @Override
            public void onItemLongClick(View view, int position) {
                imageList.remove(position);
                imageAdapter.deleteImage(position);
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK) {
            switch (requestCode) {
                case PictureConfig.CHOOSE_REQUEST:
                    List<LocalMedia> selectList = PictureSelector.obtainMultipleResult(data);
                    for (LocalMedia media : selectList) {
                        File file = new File(media.getCompressPath());
                        if (file.length() <= Constant.IMAGE_MINUS_SIZE) {
                            ToastHelper.showToast("图片尺寸太小，请重新选择", ToastHelper.ERROR);
                            continue;
                        }
                        uploadImagePresenter.onReadyRetrofitRequest(file);
                    }
                    break;
                case PictureConfig.REQUEST_CAMERA:
                    LocalMedia localMedia = PictureSelector.obtainMultipleResult(data).get(0);
                    uploadImagePresenter.onReadyRetrofitRequest(new File(localMedia.getCompressPath()));
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = viewBinding.longitudeView.getText().toString();
        String latitude = viewBinding.latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            ToastHelper.showToast("经纬度异常，请重新选择位置", ToastHelper.WARING);
            return;
        }
        String shopKeeper = viewBinding.shopKeeperView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(shopKeeper)) {
            ToastHelper.showToast("店主名还未填写", ToastHelper.WARING);
            return;
        }
        String phoneNumber = viewBinding.phoneNumberView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(phoneNumber)) {
            ToastHelper.showToast("电话号码还未填写", ToastHelper.WARING);
            return;
        }
        if (StringHelper.isPhoneNumber(phoneNumber)) {
            String fieldIntro = viewBinding.caseLocationView.getText().toString().trim().replace(" ", "");
            if (TextUtils.isEmpty(fieldIntro)) {
                ToastHelper.showToast("案卷地点还未填写", ToastHelper.WARING);
                return;
            }
            String description = viewBinding.caseDetailEditView.getText().toString().trim().replace(" ", "");
            if (TextUtils.isEmpty(description)) {
                ToastHelper.showToast("案卷情况还未填写", ToastHelper.WARING);
                return;
            }
            if (imageAdapter.getItemCount() != 2) {
                ToastHelper.showToast("必须选择两张图片", ToastHelper.WARING);
                return;
            }
            shopCaseSubmitPresenter.onReadyRetrofitRequest("0", "0", longitude, latitude,
                    "2", "1",
                    gridId.substring(0, 6),
                    gridId.substring(0, 9),
                    gridId.substring(0, 12),
                    gridId, description, fieldIntro,
                    StringHelper.reformatURL(imageList), 0, 0, shopID, shopKeeper, phoneNumber);
        } else {
            ToastHelper.showToast("电话号码格式不对", ToastHelper.WARING);
        }
    }

    @Override
    public void showProgress() {
        submitDialog.show();
    }

    @Override
    public void hideProgress() {
        submitDialog.dismiss();
    }

    @Override
    public void obtainSubmitResult(ActionResultBean resultBean) {
        if (resultBean.isSuccess()) {
            ToastHelper.showToast("提交成功", ToastHelper.SUCCESS);
            finish();
        } else {
            ToastHelper.showToast("提交失败，请重试", ToastHelper.ERROR);
        }
    }

    @Override
    public void obtainDataFail() {
        ToastHelper.showToast("操作失败", ToastHelper.ERROR);
        //TODO 案卷如果在网络极差的情况下，提交超时导致失败了，需要保存到本地吗？等下次打开的是时候提醒用户补提交之前没提交成功的案卷？
    }

    @Override
    public void obtainUploadAudioResult(ActionResultBean resultBean) {

    }

    @Override
    public void obtainUploadImageResult(ActionResultBean resultBean) {
        if (resultBean.isSuccess()) {
            PictureFileUtils.deleteAllCacheDirFile(this);
            /**
             * 系统路径static拼接图片返回路径
             * http://111.198.10.15:11409/static/2021-04/000bcf78345f4c1c86484efa3f9d68a2.jpeg
             */
            //2021-04\\000bcf78345f4c1c86484efa3f9d68a2.jpeg
            if (imageAdapter.getItemCount() <= 2) {
                String url = resultBean.getData();
                imageList.add(url);
                realPaths.add(StringHelper.appendCompleteURL(url));
                imageAdapter.setupImage(realPaths);
            } else {
                ToastHelper.showToast("最多只能上传2张图片", ToastHelper.WARING);
            }
        }
    }

    @Override
    public void obtainUploadVideoResult(ActionResultBean resultBean) {

    }

    @Override
    protected void onDestroy() {
        if (uploadImagePresenter != null) {
            uploadImagePresenter.disposeRetrofitRequest();
        }
        if (shopCaseSubmitPresenter != null) {
            shopCaseSubmitPresenter.disposeRetrofitRequest();
        }
        super.onDestroy();
    }
}
